/*
 * EnabledProblem.java
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class EnabledProblem extends JFrame 
{
  
  static JButton button1Button = new JButton();
  static JButton button2Button = new JButton();

  public static void main(String args[]) 
  {
    // construct frame
    new EnabledProblem().show();
  }

  public EnabledProblem() 
  {
    // frame constructor
    setTitle("Enabled Problem");
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent e) 
      {
        exitForm(e);
      }
    });
    getContentPane().setLayout(new GridBagLayout());

    // add buttons and method listeners
    GridBagConstraints gridConstraints = new GridBagConstraints();
    button1Button.setText("Button 1");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    getContentPane().add(button1Button, gridConstraints);
    button1Button.addActionListener(new ActionListener() 
    {
      public void actionPerformed(ActionEvent e) 
      {
        button1ButtonActionPerformed(e);
      }
    });
    button2Button.setText("Button 2");
    button2Button.setEnabled(false);
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    getContentPane().add(button2Button, gridConstraints);
    button2Button.addActionListener(new ActionListener() 
    {
      public void actionPerformed(ActionEvent e) 
      {
        button2ButtonActionPerformed(e);
      }
    });
    
    pack();
    
  }
  
  private void button1ButtonActionPerformed(ActionEvent e)
  {
    // change enabled properties
    button1Button.setEnabled(false);
    button2Button.setEnabled(true);
  }

  private void button2ButtonActionPerformed(ActionEvent e)
  {
    // change enabled properties
    button1Button.setEnabled(true);
    button2Button.setEnabled(false);
  }

  private void exitForm(WindowEvent e) 
  {
    System.exit(0);
  }
}
