/*
 * Statistics.java
 * KIDware (206) 721-2556
 */
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class Statistics extends JFrame 
{
	
	static JLabel numberLabel = new JLabel();
	static JLabel inputLabel = new JLabel();
	static JLabel meanLabel = new JLabel();
	static JLabel stdDevLabel = new JLabel();
	static JTextField numberTextField = new JTextField();
	static JTextField inputTextField = new JTextField();
	static JTextField meanTextField = new JTextField();
	static JTextField stdDevTextField = new JTextField();
	static JButton acceptButton = new JButton();
	static JButton newButton = new JButton();
	static JButton computeButton = new JButton();
	static JButton exitButton = new JButton();
	
	static int numValues;
  static double sumX;
  static double sumX2;


  public static void main(String args[]) 
  {
  	//construct frame
    new Statistics().show();
  }

  public Statistics() 
  {
  	// code to build the form
    setTitle("Mean and Standard Deviation");
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent e) 
      {
    		exitForm(e);
      }
    });
    getContentPane().setLayout(new GridBagLayout());
    
    // position controls (establish event methods)
    GridBagConstraints gridConstraints = new GridBagConstraints();
    numberLabel.setText("Number of Values");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    getContentPane().add(numberLabel, gridConstraints);
    inputLabel.setText("Enter Number");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    getContentPane().add(inputLabel, gridConstraints);
    meanLabel.setText("Mean");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 4;
    getContentPane().add(meanLabel, gridConstraints);
    stdDevLabel.setText("Standard Deviation");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 5;
    getContentPane().add(stdDevLabel, gridConstraints);
    
    numberTextField.setText("");
    numberTextField.setColumns(15);
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 0;
    getContentPane().add(numberTextField, gridConstraints);
    inputTextField.setText("");
    inputTextField.setColumns(15);
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 1;
    getContentPane().add(inputTextField, gridConstraints);
    inputTextField.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		inputTextFieldActionPerformed(e);
    	}
    });
    meanTextField.setText("");
    meanTextField.setColumns(15);
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 4;
    getContentPane().add(meanTextField, gridConstraints);
    stdDevTextField.setText("");
    stdDevTextField.setColumns(15);
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 5;
    getContentPane().add(stdDevTextField, gridConstraints);

    acceptButton.setText("Accept Number");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 2;
    getContentPane().add(acceptButton, gridConstraints);
    acceptButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		acceptButtonActionPerformed(e);
    	}
    });
    newButton.setText("New Sequence");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 3;
    getContentPane().add(newButton, gridConstraints);
    newButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		newButtonActionPerformed(e);
    	}
    });
    computeButton.setText("Compute");
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 2;
    getContentPane().add(computeButton, gridConstraints);
    computeButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		computeButtonActionPerformed(e);
    	}
    });
    exitButton.setText("Exit");
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 3;
    getContentPane().add(exitButton, gridConstraints);
    exitButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		exitButtonActionPerformed(e);
    	}
    });
    pack();
		newButton.doClick();
	}
	
  private void inputTextFieldActionPerformed(ActionEvent e)
  {
  	acceptButton.doClick();
  }
  
	private void acceptButtonActionPerformed(ActionEvent e)
	{
		double value;
    // make sure it is a valid number
    if (!validateDecimalNumber(inputTextField))
    {
    	return;
    }
    // Get number and sum number and number-squared
    numValues ++;
    numberTextField.setText(String.valueOf(numValues));
    value = Double.valueOf(inputTextField.getText()).doubleValue();
    sumX += value;
    sumX2 += value * value;
    inputTextField.setText("");
    inputTextField.requestFocus();
	}

	private void newButtonActionPerformed(ActionEvent e)
	{
		// Initialize all variables
    numValues = 0;
    numberTextField.setText("0");
    inputTextField.setText("");
    meanTextField.setText("");
    stdDevTextField.setText("");
    sumX = 0;
    sumX2 = 0;
    inputTextField.requestFocus();
	}

	private void computeButtonActionPerformed(ActionEvent e)
	{
		double mean;
		double stdDev;
    // Make sure there are at least two values
    if (numValues < 2)
    {
    	Toolkit.getDefaultToolkit().beep();
     	return;
    }
    mean = sumX / numValues;
    meanTextField.setText(String.valueOf(mean));
    // Compute standard deviation
    stdDev = Math.sqrt((numValues * sumX2 - sumX * sumX) / (numValues * (numValues - 1)));
    stdDevTextField.setText(String.valueOf(stdDev));
    inputTextField.requestFocus();
	}

	private void exitButtonActionPerformed(ActionEvent e)
	{
  	System.exit(0);
	}

  private void exitForm(WindowEvent e)
  {
  	System.exit(0);
  }

	public boolean validateDecimalNumber(JTextField tf)
	{
		// checks to see if text field contains
		// valid decimal number with only digits and a single decimal point
		String s = tf.getText().trim();
		boolean hasDecimal = false;
		boolean valid = true;
		if (s.length() == 0)
		{
			valid = false;
		}
		else
		{
			for (int i = 0; i < s.length(); i++)
			{
				char c = s.charAt(i);
				if ((c >= '0' && c <= '9') || (c == '-' && i == 0))
				{
					continue;
				}
				else if (c == '.' && !hasDecimal)
				{
					hasDecimal = true;
				}
				else
				{
					// invalid character found
					valid = false;
				}
			}
		}
		if (valid)
		{
			tf.setText(s);
		}
		else
		{
			tf.setText("");
			tf.requestFocus();
		}
		return (valid);
	}
	

}
