/*
 * ListBoxProblem.java
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class ListBoxProblem extends JFrame 
{
  static DefaultListModel statesListModel = new DefaultListModel();
	static JList statesList = new JList();
  static JScrollPane statesScrollPane = new JScrollPane();
  static DefaultListModel otherListModel = new DefaultListModel();
  static JList otherList = new JList();
  static JScrollPane otherScrollPane = new JScrollPane();
  static JButton move1Button = new JButton();
  static JButton move2Button = new JButton();

  public static void main(String args[]) 
  {
  	// construct frame
    new ListBoxProblem().show();

    // populate states (you can use another list if you like)
    statesListModel = new DefaultListModel();
    statesListModel.addElement("Alabama"); statesListModel.addElement("Alaska");
    statesListModel.addElement("Arizona"); statesListModel.addElement("Arkansas");
    statesListModel.addElement("California"); statesListModel.addElement("Colorado");
    statesListModel.addElement("Connecticut"); statesListModel.addElement("Delaware");
    statesListModel.addElement("Florida"); statesListModel.addElement("Georgia");
    statesListModel.addElement("Hawaii"); statesListModel.addElement("Idaho");
    statesListModel.addElement("Illinois"); statesListModel.addElement("Indiana");
    statesListModel.addElement("Iowa"); statesListModel.addElement("Kansas");
    statesListModel.addElement("Kentucky"); statesListModel.addElement("Louisiana");
    statesListModel.addElement("Maine"); statesListModel.addElement("Maryland");
    statesListModel.addElement("Massachusetts"); statesListModel.addElement("Michigan");
    statesListModel.addElement("Minnesota"); statesListModel.addElement("Mississippi");
    statesListModel.addElement("Missouri"); statesListModel.addElement("Montana");
    statesListModel.addElement("Nebraska"); statesListModel.addElement("Nevada");
    statesListModel.addElement("New Hampshire"); statesListModel.addElement("New Jersey");
    statesListModel.addElement("New Mexico"); statesListModel.addElement("New York");
    statesListModel.addElement("North Carolina"); statesListModel.addElement("North Dakota");
    statesListModel.addElement("Ohio"); statesListModel.addElement("Oklahoma");
    statesListModel.addElement("Oregon"); statesListModel.addElement("Pennsylvania");
    statesListModel.addElement("Rhode Island"); statesListModel.addElement("South Carolina");
    statesListModel.addElement("South Dakota"); statesListModel.addElement("Tennessee");
    statesListModel.addElement("Texas"); statesListModel.addElement("Utah");
    statesListModel.addElement("Vermont"); statesListModel.addElement("Virginia");
    statesListModel.addElement("Washington"); statesListModel.addElement("West Virginia");
    statesListModel.addElement("Wisconsin"); statesListModel.addElement("Wyoming");
    statesList.setModel(statesListModel);
  }
  
  public ListBoxProblem() 
  {
    // create frame
    setTitle("List Box Problem");
    setResizable(false);
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent e) 
      {
        exitForm(e);
      }
    });
    getContentPane().setLayout(new GridBagLayout());
    
    // position controls
    
    GridBagConstraints gridConstraints;

    statesScrollPane.setPreferredSize(new Dimension(150, 100));
    statesScrollPane.setViewportView(statesList);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    gridConstraints.insets = new Insets(10, 10, 10, 10);
    getContentPane().add(statesScrollPane, gridConstraints);
    
    otherScrollPane.setPreferredSize(new Dimension(150, 100));
    otherScrollPane.setViewportView(otherList);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 0;
    gridConstraints.insets = new Insets(10, 10, 10, 10);
    getContentPane().add(otherScrollPane, gridConstraints);
    otherList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    
    move1Button.setText("Move Items >>");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    getContentPane().add(move1Button, gridConstraints);
    move1Button.addActionListener(new ActionListener() 
    {
      public void actionPerformed(ActionEvent e) 
      {
        move1ButtonActionPerformed(e);
      }
    });
 
    move2Button.setText("<< Move Item");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 1;
    getContentPane().add(move2Button, gridConstraints);
    move2Button.addActionListener(new ActionListener() 
    {
      public void actionPerformed(ActionEvent e) 
      {
        move2ButtonActionPerformed(e);
      }
    });
 
    pack();
   	Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((int) (0.5 * (screenSize.width - getWidth())), (int) (0.5 * (screenSize.height - getHeight())), getWidth(), getHeight());

	}
  
  private void move1ButtonActionPerformed(ActionEvent e) 
  {
  	int[] indices;
		// Move selected items to other list box
    // always move and remove top (0th) element since indices change
  	while (!statesList.isSelectionEmpty())
  	{ 
    	indices = statesList.getSelectedIndices();
    	otherListModel.addElement(statesListModel.getElementAt(indices[0]));
  		statesListModel.removeElementAt(indices[0]);
  	}
 		otherList.setModel(otherListModel);
	}

  private void move2ButtonActionPerformed(ActionEvent e) 
  {
		// Move selected item back to states list box
		int index;
		int i;
		String item;
  	index = otherList.getSelectedIndex();
   	item = otherListModel.getElementAt(index).toString();
   	// bubble sort to see where item goes in list to maintain order
   	if (item.compareTo(statesListModel.getElementAt(statesListModel.size() - 1).toString()) > 0)
   	{
   	  // item goes at end
   	  statesListModel.addElement(item);
   	} 
   	else
   	{
   		for (i = statesListModel.size() - 1; i >= 0; i--)
   		{
   			if ((statesListModel.getElementAt(i).toString().compareTo(item)) < 0)
   			{
   				break;
   			}
   		}
   		statesListModel.insertElementAt(item, i + 1);
   	}
   	otherListModel.removeElementAt(index);
  }


  private void exitButtonActionPerformed(ActionEvent e) 
  {
    System.exit(0);
  }
  
  private void exitForm(WindowEvent e) 
  {
    System.exit(0);
  }
  
}
