/*
 * DateInput.java
 */

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

public class DateInput extends JFrame 
{
  static JSpinner monthSpinner = new JSpinner();
  static JSpinner daySpinner = new JSpinner();
  static JLabel dateLabel = new JLabel();

  static String[] monthNames = new String[12];

	public static void main(String args[]) 
  {
    // add month names
    monthNames[0] = "January";
    monthNames[1] = "February";
    monthNames[2] = "March";
    monthNames[3] = "April";
    monthNames[4] = "May";
    monthNames[5] = "June";
    monthNames[6] = "July";
    monthNames[7] = "August";
    monthNames[8] = "September";
    monthNames[9] = "October";
    monthNames[10] = "November";
    monthNames[11] = "December";

    // create frame
    new DateInput().show();
  }

  public DateInput() 
  {
    // frame constructor
    setTitle("Date Input");
    setResizable(false);
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent evt) 
      {
        exitForm(evt);
      }
    });
    getContentPane().setLayout(new GridBagLayout());
    
    // position controls

    GridBagConstraints gridConstraints;
    monthSpinner.setPreferredSize(new Dimension(150, 30));
    monthSpinner.setModel(new SpinnerListModel(monthNames));
    ((JSpinner.DefaultEditor) monthSpinner.getEditor()).getTextField().setFont(new Font("Arial", Font.PLAIN, 18));
    ((JSpinner.DefaultEditor) monthSpinner.getEditor()).getTextField().setForeground(Color.BLUE);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    gridConstraints.insets = new Insets(10, 10, 10, 10);
    getContentPane().add(monthSpinner, gridConstraints);
    monthSpinner.addChangeListener(new ChangeListener()
    {
      public void stateChanged(ChangeEvent e) 
      {
        dateStateChanged(e);
      }
    });

    
    daySpinner.setPreferredSize(new Dimension(100, 30));
    SpinnerNumberModel dayNumberModel = new SpinnerNumberModel(1, 1, 31, 1);
    daySpinner.setModel(dayNumberModel);
    ((JSpinner.DefaultEditor) daySpinner.getEditor()).getTextField().setHorizontalAlignment(SwingConstants.CENTER);
    ((JSpinner.DefaultEditor) daySpinner.getEditor()).getTextField().setFont(new Font("Arial", Font.PLAIN, 18));
    ((JSpinner.DefaultEditor) daySpinner.getEditor()).getTextField().setForeground(Color.BLUE);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 0;
    gridConstraints.insets = new Insets(10, 10, 10, 10);
    getContentPane().add(daySpinner, gridConstraints);
    daySpinner.addChangeListener(new ChangeListener()
    {
      public void stateChanged(ChangeEvent e) 
      {
        dateStateChanged(e);
      }
    });

    
    dateLabel.setText("January 1");
    dateLabel.setFont(new Font("Arial", Font.BOLD, 24));
    dateLabel.setHorizontalAlignment(SwingConstants.CENTER);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    gridConstraints.gridwidth = 2;
    gridConstraints.insets = new Insets(0, 0, 10, 0);
    getContentPane().add(dateLabel, gridConstraints);

    
    pack();
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((int) (0.5 * (screenSize.width - getWidth())), (int) (0.5 * (screenSize.height - getHeight())), getWidth(), getHeight());
   
  }
  private void dateStateChanged(ChangeEvent e)
  {
    dateLabel.setText(monthSpinner.getValue() + " " + daySpinner.getValue());
  }

  private void exitForm(WindowEvent evt) 
  {
    System.exit(0);
  }
}
