/*
 * FileTimes.java
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class FileTimes extends JFrame 
{
	static JFileChooser fileChooser = new JFileChooser();
	static JScrollPane timeScrollPane = new JScrollPane();
	static JTextArea timeTextArea = new JTextArea();
	static JButton timeButton = new JButton();

  public static void main(String args[]) 
  {
  	//construct frame
    new FileTimes().show();
  }

  public FileTimes() 
  {
  	// create frame
    setTitle("File Times Problem");
    setResizable(false);
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent e) 
      {
    		exitForm(e);
      }
    });
    getContentPane().setLayout(new GridBagLayout());

    // position controls
    GridBagConstraints gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    getContentPane().add(fileChooser, gridConstraints);

    timeScrollPane.setPreferredSize(new Dimension(200, 300));
    timeScrollPane.setViewportView(timeTextArea);
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 0;
    gridConstraints.anchor = GridBagConstraints.NORTH;
    gridConstraints.insets = new Insets(10, 10, 10, 10);
    getContentPane().add(timeScrollPane, gridConstraints);

    timeButton.setText("File Times");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 1;
    gridConstraints.insets = new Insets(10, 0, 10, 0);
    getContentPane().add(timeButton, gridConstraints);
    timeButton.addActionListener(new ActionListener() 
    {
      public void actionPerformed(ActionEvent evt) 
      {
        timeButtonActionPerformed(evt);
      }
    });
     
    pack();
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((int) (0.5 * (screenSize.width - getWidth())), (int) (0.5 * (screenSize.height - getHeight())), getWidth(), getHeight());

	}
  private void timeButtonActionPerformed(ActionEvent evt)
  {
  	// check all files in directory for last modified times
  	final int gmtDiff = -7;
  	int[] hourCount = new int[24];
  	long modifyTime;
  	int d, h;
  	String fileTimes = "";
    for (int i = 0; i < 24; i++)
    {
    	hourCount[0] = 0;
    }
    // Cycle through all files, determining time
    // skip if a directory
  	File[] myFiles = fileChooser.getCurrentDirectory().listFiles();
  	for (int i = 0; i < myFiles.length; i++)
  	{
  		if (!myFiles[i].isDirectory())
  		{
  			// get the modify time in seconds
  			modifyTime = (int) (myFiles[i].lastModified() / 1000);
  			// retrieve number of days
				d = (int) (modifyTime / (24 * 60 * 60));
				// retrieve hour
				h = (int) ((modifyTime - d * 24 * 60 * 60) / 3600);
				// adjust for Greenwich mean time
				h += gmtDiff;
				if (h < 0)
				{
					h += 24;
				}
				else if (h > 23)
				{
					h -= 24;
				}
				hourCount[h]++;
  		}
  	}
  	// display hour counts in text area
  	for (int i = 0; i < 24; i++)
  	{
  		fileTimes += "Hour: " + String.valueOf(i) + ", Count: " + String.valueOf(hourCount[i]) + "\n";
  	}
  	timeTextArea.setText(fileTimes);
  	

  }

  private void exitForm(WindowEvent e)
  {
  	System.exit(0);
  }

}
